- Research Article
15
- 10.1016/j.tcs.2018.10.030
FPT algorithms for domination in sparse graphs and beyond
- Oct 25, 2018
- Theoretical Computer Science
- J.A Telle + 1 more +1
FPT algorithms for domination in sparse graphs and beyond
Two graphs G and H with the same vertex set Vare P4 -isomorphic if every four vertices {a,b,c,d} \subseteq V$ induce a chordless path (denoted by P4 ) in G if and only if they induce a P4 in H. We call a graph split-perfect if it is P4 -isomorphic to a split graph (i.e., a graph being partitionable into a clique and a stable set). This paper characterizes the new class of split-perfect graphs using the concepts of homogeneous sets and p-connected graphs and leads to a linear time recognition algorithm for split-perfect graphs, as well as efficient algorithms for classical optimization problems on split-perfect graphs based on the primeval decomposition of graphs. The optimization results considerably extend previous ones on smaller classes such as P4 --sparse graphs, P4 -lite graphs, P4 --laden graphs, and (7,3)-graphs. Moreover, split-perfect graphs form a new subclass of brittle graphs containing the superbrittle graphs for which a new characterization is obtained leading to linear time recognition.
FPT algorithms for domination in sparse graphs and beyond
FPT algorithms for domination in sparse graphs and beyond
Temporal Cliques Admit Sparse Spanners
Let $G=(V,E)$ be an undirected graph on $n$ vertices and $\lambda:E\to 2^{\mathbb{N}}$ a mapping that assigns to every edge a non-empty set of positive integer labels. These labels can be seen as discrete times when the edge is present. Such a labeled graph ${\cal G}=(G,\lambda)$ is said to be temporally connected if a path exists with non-decreasing times from every vertex to every other vertex. In a seminal paper, Kempe, Kleinberg, and Kumar (STOC 2000) asked whether, given such a temporal graph, a sparse subset of edges can always be found whose labels suffice to preserve temporal connectivity---a temporal spanner. Axiotis and Fotakis (ICALP 2016) answered negatively by exhibiting a family of $\Theta(n^2)$-dense temporal graphs which admit no temporal spanner of density $o(n^2)$. The natural question is then whether sparse temporal spanners can always be found in some classes of dense graphs. In this paper, we answer this question affirmatively, by showing that if the underlying graph $G$ is a complete graph, then one can always find temporal spanners of density $O(n \log n)$. The best known result for complete graphs so far was that spanners of density ${n \choose 2}- \lfloor n/4 \rfloor = O(n^2)$ always exist. Our result is the first positive answer as to the existence of $o(n^2)$ sparse spanners in adversarial instances of temporal graphs since the original question by Kempe et al., focusing here on complete graphs. The proofs are constructive and directly adaptable as an algorithm.
Read moreThermal properties of structurally balanced systems on classical random graphs
The dynamics of social relations and the possibility of reaching the state of structural balance (Heider balance) under the influence of the temperature modeling the social noise level are discussed for interacting actors occupying nodes of classical random graphs. Depending on the graph density D, either a smooth crossover or a first-order phase transition from a balanced to an imbalanced state of the system is observed with an increase in the thermal noise level. The minimal graph density Dmin for which the first-order phase transition can be observed decreases with the system size N as Dmin∝N−0.58(1). For graph densities D>Dmin, the reduced critical temperature Tc⋆=Tc/Tc(D=1) increases with the graph density as Tc⋆∝D1.719(6) independently of the system size N.
Read moreSpace Efficient Linear Time Algorithms for BFS, DFS and Applications
Research on space efficient graph algorithms, particularly for st-connectivity, has a long history including the celebrated polynomial time, O(lg n) bits1 algorithm in undirected graphs by Reingold J. JACM. 55(4) (2008), and polynomial time, \(n/2^{\Theta (\sqrt {\lg n})}\) bits algorithm in directed graphs by Barnes et al. SICOMP. 27(5), 1273–1282 (1998). Recent works by Asano et al. ISAAC (2014) and Elmasry et al. STACS (2015), reconsidered classical fundamental graph algorithms focusing on improving the space complexity. Elmasry et al. gave, among others, an implementation of breadth first search (BFS) in a graph G with n vertices and m edges, taking the optimal O(m + n) time using O(n) bits improving the naive O(n lg n) bits implementation. Similarly, Asano et al. provided space efficient implementations for performing depth first search (DFS) in a graph G. We continue this line of work focusing on improving the space requirement for implementing a few classical graph algorithms. Our first result is a simple data structure that can maintain any subset S of a universe of u elements using just u + o(u) bits and supports in constant time, apart from the standard insert, delete and membership queries, the operation findany that finds and returns any element of the set (or outputs that the set is empty). It can also enumerate all elements present currently in the set in no particular order in O(k + 1) time where k is the number of elements currently belonging to the set. While this data structure supports a weaker set of operations than that of Elmasry et al. STACS (2015), it is simple, more space efficient and is sufficient to support a BFS implementation optimally in O(m + n) time using at most 2n + o(n) bits. Later, we further improve the space requirement of BFS to at most n lg 3 + o(n) bits albeit with a slight increase in running time to O(m lg nf(n)) time where f(n) is any extremely slow growing function of n, and the o term in the space is a function of f(n). We also discuss a similar time-space tradeoff result for finding a minimum weight spanning tree of a weighted (bounded by polynomial in n) undirected graph using n + O(n/f(n)) bits and O(m lg nf(n)) time, for any function f(n) such that 1 ≤ f(n) ≤ n. For DFS in a graph G, we provide an implementation taking O(m + n) time and O(n lg m/n) bits. This partially answers at least for sparse graphs, a question asked by Asano et al. ISAAC (2014) whether DFS can be performed in O (m + n) time and using O(n) bits, and also simultaneously improves the DFS result of Elmasry et al. STACS (2015). Using our DFS algorithm and other careful implementations, we show how one can also test for biconnectivity, 2-edge connectivity, and find cut vertices and bridges of a given undirected graph within the same time and space bounds; earlier classical linear time algorithms for these problems used Ω(n lg n) bits of space.
Read moreOn External-Memory Planar Depth-First Search
Even though a large number of I/O-efficient graph algorithms have been developed, a number of fundamental problems still remain open. For example, no space- and I/O-efficient algorithms are known for depth-first search or breadth-first search in sparse graphs. In this paper we present two new results on I/O-efficient depth-first search in an important class of sparse graphs, namely undirected embedded planar graphs. We develop a new efficient depth-first search algorithm and show how planar depth-first search in general can be reduced to planar breadth-first search. As part of the first result we develop the first I/O-efficient algorithm for finding a simple cycle separator of a biconnected planar graph. Together with other recent reducibility results, the second result provides further evidence that external memory breadth-first search is among the hardest problems on planar graphs.
Read moreOn External-Memory Planar Depth First Search
Even though a large number of I/O-efficient graph algorithms have been developed, a number of fundamental problems still remain open. For example, no space- and I/O-efficient algorithms are known for depth-first search or breadth-first search in sparse graphs. In this paper we present two new results on I/O-efficient depth-first search in an important class of sparse graphs, namely undirected embedded planar graphs. We develop a new efficient depth-first search algorithm and show how planar depth-first search in general can be reduced to planar breadth-first search. As part of the first result we develop the first I/O-efficient algorithm for finding a simple cycle separator of a biconnected planar graph. Together with other recent reducibility results, the second result provides further evidence that external memory breadth-firstsearch is among the hardest problems on planar graphs.KeywordsPlanar GraphExternal MemorySimple CycleOuterplanar GraphBoundary CycleThese keywords were added by machine and not by the authors. This process is experimental and the keywords may be updated as the learning algorithm improves.
Read moreReconfiguration on Sparse Graphs
A vertex-subset graph problem \(\mathcal {Q}\) defines which subsets of the vertices of an input graph are feasible solutions. A reconfiguration variant of a vertex-subset problem asks, given two feasible solutions \(S_s\) and \(S_t\) of size k, whether it is possible to transform \(S_s\) into \(S_t\) by a sequence of vertex additions and deletions such that each intermediate set is also a feasible solution of size bounded by k. We study reconfiguration variants of two classical vertex-subset problems, namely Independent Set and Dominating Set. We denote the former by \(\textsc {ISR}\) and the latter by \(\textsc {DSR}\). Both \(\textsc {ISR}\) and \(\textsc {DSR}\) are PSPACE-complete on graphs of bounded bandwidth and W[1]-hard parameterized by k on general graphs. We show that \(\textsc {ISR}\) is fixed-parameter tractable parameterized by k when the input graph is of bounded degeneracy or nowhere dense. As a corollary, we answer positively an open question concerning the parameterized complexity of the problem on graphs of bounded treewidth. Moreover, our techniques generalize recent results showing that \(\textsc {ISR}\) is fixed-parameter tractable on planar graphs and graphs of bounded degree. For \(\textsc {DSR}\), we show the problem fixed-parameter tractable parameterized by k when the input graph does not contain large bicliques, a class of graphs which includes degenerate and nowhere dense graphs.
Read moreMinimal separators in P4-tidy graphs
Minimal separators in <mml:math xmlns:mml="http://www.w3.org/1998/Math/MathML" altimg="si1.gif" overflow="scroll"><mml:msub><mml:mi>P</mml:mi><mml:mn>4</mml:mn></mml:msub></mml:math>-tidy graphs
Read moreEfficient Exact Algorithms for Maximum Balanced Biclique Search in Bipartite Graphs
Given a bipartite graph, the maximum balanced biclique (MBB) problem, discovering a mutually connected while disjoint sets of equal size with the maximum cardinality, plays a significant role for mining the bipartite graph and has numerous applications. Despite the NP-hardness of the MBB problem, in this paper, we show that an exact MBB can be discovered extremely fast in bipartite graphs for real applications. We propose two exact algorithms dedicated for small dense and large sparse bipartite graphs respectively. For dense bipartite graphs, an O*(1.3803n) algorithm is proposed. This algorithm in fact can find an MBB very fast for small dense bipartite graphs that are common for applications such as VLSI design. This is because, using our proposed novel techniques, the search can fast converge to sufficiently dense bipartite graphs which we prove to be polynomial-time solvable. For large sparse bipartite graphs typical for applications such as biological data analysis, an O*(1.3803 δ) algorithm is proposed, where δ is only a few hundred for large sparse bipartite graphs with millions of vertices. The indispensible optimization that leads to this time complexity is: we transform a large sparse bipartite graph into a limited number of dense subgraphs such that each of the dense subgraphs has up to δ vertices and then apply our proposed algorithm for dense bipartite graphs on each of the subgraphs. To further speed up this algorithm, tighter upper bounds, faster heuristics and more effective reductions are proposed, allowing an MBB to be discovered within a few seconds for bipartite graphs with millions of vertices. Extensive experiments are conducted on synthetic and real large bipartite graphs to demonstrate the efficiency and effectiveness of our proposed algorithms and techniques.
Read moreOn the parameterized complexity of [1,j]-domination problems
For a graph G, a set D⊆V(G) is called a [1,j]-dominating set if every vertex in V(G)∖D has at least one and at most j neighbors in D. A set D⊆V(G) is called a [1,j]-total dominating set if every vertex in V(G) has at least one and at most j neighbors in D. In the [1,j]-(Total) Dominating Set problem we are given a graph G and a positive integer k. The objective is to test whether there exists a [1,j]-(total) dominating set of size at most k. The [1,j]-Dominating Set problem is known to be NP-complete, even for restricted classes of graphs such as chordal and planar graphs, but polynomial-time solvable on split graphs. The [1,2]-Total Dominating Set problem is known to be NP-complete, even for bipartite graphs. As both problems generalize the Dominating Set problem, both are W[1]-hard when parameterized by solution size. In this work, we study the aforementioned problems on various graph classes from the perspective of parameterized complexity and prove the following results:•[1,j]-Dominating Set parameterized by solution size is W[1]-hard on d-degenerate graphs for d=j+1.•[1,j]-Dominating Set parameterized by solution size is FPT on nowhere dense graphs.•The known algorithm for [1,j]-Dominating Set on split graphs is optimal under the Strong Exponential Time Hypothesis (SETH).•Assuming SETH, we provide a lower bound for the running time of any algorithm solving the [1,2]-Total Dominating Set problem parameterized by pathwidth.•Finally, we study another variant of Dominating Set, called Restrained Dominating Set, that asks if there is a dominating set D of G of size at most k such that no vertex outside of D has all of its neighbors in D. We prove this variant is W[1]-hard even on 3-degenerate graphs.
Read moreCircular Ones Matrices and the Stable Set Polytope of Quasi-Line Graphs
It is a long standing open problem to find an explicit description of the stable set polytope of claw-free graphs. Yet more than 20 years after the discovery of a polynomial algorithm for the maximum stable set problem for claw-free graphs, there is even no conjecture at hand today.Such a conjecture exists for the class of quasi-line graphs. This class of graphs is a proper superclass of line graphs and a proper subclass of claw-free graphs for which it is known that not all facets have 0/1 normal vectors. Ben Rebea’s conjecture states that the stable set polytope of a quasi-line graph is completely described by clique-family inequalities. Chudnovsky and Seymour recently provided a decomposition result for claw-free graphs and proved that Ben Rebea’s conjecture holds, if the quasi-line graph is not a fuzzy circular interval graph.In this paper, we give a proof of Ben Rebea’s conjecture by showing that it also holds for fuzzy circular interval graphs. Our result builds upon an algorithm of Bartholdi, Orlin and Ratliff which is concerned with integer programs defined by circular ones matrices.KeywordsNegative CycleClique InequalityHeavy EdgeRational PolyhedronLight EdgeThese keywords were added by machine and not by the authors. This process is experimental and the keywords may be updated as the learning algorithm improves.
Read moreStable sets and polynomials
Stable sets and polynomials
Independence polynomials of well-covered graphs: Generic counterexamples for the unimodality conjecture
Independence polynomials of well-covered graphs: Generic counterexamples for the unimodality conjecture
Sparse Graph Based Sketching for Fast Numerical Linear Algebra
In recent years, a variety of randomized constructions of sketching matrices have been devised, that have been used in fast algorithms for numerical linear algebra problems, such as least squares regression, low-rank approximation, and the approximation of leverage scores. A key property of sketching matrices is that of subspace embedding. In this paper, we study sketching matrices that are obtained from bipartite graphs that are sparse, i.e., have left degree s that is small. In particular, we explore two popular classes of sparse graphs, namely, expander graphs and magical graphs. For a given subspace ${\mathcal{U}} \subseteq {{\mathbb{R}}^n}$ of dimension k, we show that the magical graph with left degree s = 2 yields a (1 ± ϵ) ℓ <inf xmlns:mml="http://www.w3.org/1998/Math/MathML" xmlns:xlink="http://www.w3.org/1999/xlink">2</inf> -subspace embedding for ${\mathcal{U}}$, if the number of right vertices (the sketch size) $m = {\mathcal{O}}\left( {{k^2}/{\varepsilon ^2}} \right)$. The expander graph with $s = {\mathcal{O}}(\log k/\varepsilon )$ yields a subspace embedding for $m = {\mathcal{O}}\left( {k\log k/{\varepsilon ^2}} \right)$. We also discuss the construction of sparse sketching matrices with reduced randomness using expanders based on error-correcting codes. Empirical results on various synthetic and real datasets show that these sparse graph sketching matrices work very well in practice.
Read moreSelecting the appropriate size of the graph for self-diagnostic model with graph density
<p>Self-diagnosis is the concept of self-diagnosing disease from symptoms. We have the idea to create self-diagnostic models from diagnostic data. The data to be analyzed were from a medium-sized hospital in Thailand. The model is divided by structured data and unstructured data. The first step is to process structured data with cluster algorithms. The second step is to evaluate the unstructured data to group symptoms into a bipartite graph. After the graph was created, the model was divided into 10 levels, according to the level of similarity. This research aims to apply the concept of density graph, the Kappas and multiple line graph to selecting the appropriate diagnosis model. The results of all three experiments showed that the appropriate model was at a level of similarity at 40%.</p>
Read more